/*
 * Primer client koda koji koristi
 * funkcije sendstring i receivestring
 * deklarisane u protocol.h da bi 
 * razmenjivao poruke sa klijentom.
 * 
 * Autor: Ikac, ikac.ikax@gmail.com
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "protocol.h"


void error(const char *msg)
{
  /*
   * funkcija koja ispisuje predatu 
   * poruku, i izlazi iz programa
   */
	perror(msg);
	exit(1);
}

int main(int argc, char *argv[])
{
	int sockfd, portno, n;
	struct sockaddr_in serv_addr;
	struct hostent *server;

	if (argc < 3) {
		fprintf(stderr,
			"usage %s hostname port \n",
			argv[0]);
		exit(0);
	}

	portno = atoi(argv[2]);
	sockfd = socket(AF_INET, SOCK_STREAM, 0);


	if (sockfd < 0)
		error("ERROR opening socket");

  /*
   * Prihvatanje podataka o serveru na
   * osnovu njegove adrese predate pri
   * pokretanju programa   
   * 
   */
	server = gethostbyname(argv[1]);


  perror("Connecting to host");
  
	bzero((char *)&serv_addr, sizeof(serv_addr));	// nuliranje cele strukture

	serv_addr.sin_family = AF_INET; //odabir Internet adresa
	bcopy((char *)server->h_addr, (char *)&serv_addr.sin_addr.s_addr,
	      server->h_length); //kopiranje adrese servera
	serv_addr.sin_port = htons(portno); //navodjenje porta na serveru
	

	if (connect(sockfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) <
	    0)
		error("ERROR connecting"); //konektovanje na zeljeni server preko sockfd socket deskriptora

	char *buffer;
  
  const short len = 256;
  
	buffer = malloc(sizeof(char)*len);
  memset(buffer, ' ', len);	//nuliranje buffera

	strcpy(buffer, "THIS IS A MESSAGE");//smestanje stringa u buffer
	n = sendstring(sockfd, buffer);	//slanje stringa serveru

	n = receivestring(sockfd, &buffer);	//prihvatanje odziva

	if(buffer) printf("%s\n", buffer);
  
  if(buffer) free(buffer);
  
	close(sockfd);//zatvaranje socketa i zavrsetak rada klijenta
	return 0;
}
