/*
 * Header fajl potreban procotol.c kodu
 * kao i klijentskom i serverskom kodu da
 * se kompajliraju.
 * 
 * Ovo je vrlo prosta verzija protokola
 * gde se ispred stringa ubaci zaglavlje
 * velicine HEADERLEN koje sadrzi broj
 * karaktera koje sadrzi poruka.
 * 
 * Nakon njega ide poruka, koja je tipa
 * string, pa se niz karaktera zavrsava sa '\0'
 * 
 * Izgled zaglavlja:
 * 
 *  -------------------
 *  |0010|0123456789\0|
 *  -------------------
 *    ||          ||
 *  zaglavlje   poruka
 * 
 * MESSAGELEN treba da ogranici broj karaktera
 * u poruci, kako bi duzina poruke
 * mogla da odgovara broju u zaglavlju
 * 
 * Implementacije funkcija sendstring i 
 * receivestring su date u protocol.c fajlu
 * 
 * Nacin kompajliranja je dat u make fajlu
 * 
 * Autor: Ikac, ikac.ikax@gmail.com
 */
 
#define HEADERLEN 4
#define MESSAGELEN (10^HEADERLEN-1)

int sendstring(int, char * );
int receivestring(int, char ** );

